package de.effigenix.application.masterdata;

import de.effigenix.domain.masterdata.*;
import de.effigenix.shared.common.Result;
import de.effigenix.shared.security.ActorId;
import org.springframework.transaction.annotation.Transactional;

import static de.effigenix.shared.common.Result.*;

@Transactional
public class ActivateSupplier {

    private final SupplierRepository supplierRepository;

    public ActivateSupplier(SupplierRepository supplierRepository) {
        this.supplierRepository = supplierRepository;
    }

    public Result<SupplierError, Supplier> execute(SupplierId supplierId, ActorId performedBy) {
        Supplier supplier;
        switch (supplierRepository.findById(supplierId)) {
            case Failure(var err) ->
                { return Result.failure(new SupplierError.RepositoryFailure(err.message())); }
            case Success(var opt) -> {
                if (opt.isEmpty()) {
                    return Result.failure(new SupplierError.SupplierNotFound(supplierId));
                }
                supplier = opt.get();
            }
        }
        supplier.activate();

        switch (supplierRepository.save(supplier)) {
            case Failure(var err) ->
                { return Result.failure(new SupplierError.RepositoryFailure(err.message())); }
            case Success(var ignored) -> { }
        }

        return Result.success(supplier);
    }
}
